# AB Tasty Widget CLI
CLI tool for AB Tasty Widgets.

<img src="https://gitlab.com/abtasty/public/storage/raw/master/widget-cli-logo.png" width="344px">

AB Tasty Widgets are NPM packages that can be embedded on any website, through [AB Tasty](https://abtasty.com).
You can find more infomation and documentation about widgets at https://abtasty.gitbooks.io/widget/.

## Prerequisites
Both the CLI and generated project have dependencies that require Node 7 or higher, together with NPM 4 or higher.

## Installation
```bash
npm install -g @abtasty/widget-cli
```

## Usage
```bash
widget --help
```

### Create new widget
The AB Tasty Widget CLI makes it easy to create a widget that already works, right out of the box. It already follows our best practices!
```bash
widget new
```

### Serve your widget
Easily preview and test your widget locally while developing.
```bash
cd my-widget
widget serve
```

## Updating
To upgrade AB Tasty Widget CLI:
```bash
npm install -g @abtasty/widget-cli@latest
```
